



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【Java基础】通过getResourceAsStream() 加载资源文件</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【Java基础】通过getResourceAsStream() 加载资源文件</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-29 09:27:10 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<ol><li><p>Class.getResourceAsStream(String path)</p>
<ul><li>path不以“/”开头时，默认是从当前类所在的包下面获取资源</li>
<li>path以“/”开头时，则是从项目的classPath根下获取资源</li></ul>
<p>JDK设置这样的规则，是很好理解的，path不以“/”开头时，我们就能获取与当前类所在的路径相同的资源文件，而以“/”开头时可以获取classPath根下任意路径的资源。</p></li>
<li><p>ClassLoader.getResourceAsStream(String path)</p>
<ul><li>默认是从classpath根下获取，<strong>path不能以“/”开头</strong>，path是指类加载器的加载范围，在资源加载的过程中，使用逐级向上的委托的形式加载的，“/”表示Boot ClassLoader中的加载范围，因为这个类加载器是C++实现的，所以加载范围为null。</li></ul></li>
<li><p>ServletContext.getResourceAsStream(String path)</p>
<ul><li>默认从WebAPP根目录下取资源，Tomcat下path是否以“/”开头无所谓，当然这和具体的容器实现有关。</li></ul></li>
<li><p>问题</p>
<p>今天在测试Class.getResourceAsStream()获取当前类所在包下面的资源文件时，一直无法正常获取，总是返回null。花了很多时间才发现Idea在编译类之后没有把我包下面的配置文件copy过去。因为Idea从13版本开始只支持外部编译，因此需要在pom.xml文件手动指定资源文件的目录。在maven中添加了以下配置之后，包下面的配置文件也就copy过去了，所以再次运行代码的时候就ok了。</p>
<pre class="prettyprint linenums"><code>&lt;build&gt;<br />
    &lt;finalName&gt;smart&lt;/finalName&gt;<br />
    &lt;resources&gt;<br />
        &lt;resource&gt;<br />
            &lt;directory&gt;src/main/java&lt;/directory&gt;&lt;!--指定资源文件目录--&gt;<br />
        &lt;/resource&gt;<br />
    &lt;/resources&gt;<br />
&lt;/build&gt;<br />
</code></pre></li></ol>
<blockquote><p>参考文章</p></blockquote>
<ol><li><a href="http://swiftlet.net/archives/868" rel="external nofollow noreferrer">http://swiftlet.net/archives/868</a></li>
<li><a href="http://blog.csdn.net/zhanghaipeng1989/article/details/19332489" rel="external nofollow noreferrer">http://blog.csdn.net/zhanghaipeng1989/article/details/19332489</a></li>
<li><a href="http://blog.163.com/moonlight_yz/blog/static/74736722013111052554300/" rel="external nofollow noreferrer">http://blog.163.com/moonlight_yz/blog/static/74736722013111052554300/</a></li></ol>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxkpnv8.html">sql with as union all</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7g32jq.html">MFC的几处坑</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4wdjj9.html">GC基本算法及C&plus;&plus;GC机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k7xx79.html">【转】在web 项目使用了ReportViewer时出错</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ez7vx8.html">Objective-C 代码规范（Code Style）</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g2pr48.html">13SpringMvc&lowbar;限定某个业务控制方法，只允许GET或POST请求方式访问</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdedevx9.html">&lbrack;转&rsqb;glew&comma; glee与 gl glu glut glx glext的区别和关系</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn122l28.html">Selenium2Library系列 keywords 之 &lowbar;SelectElementKeywords 之 select&lowbar;all&lowbar;from&lowbar;list&lpar;self&comma; locator&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn6n60q.html">缺少HTML Doctype造成的样式问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p73ry8.html">哈夫曼树压缩C&num;算法（huffman）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk5o0z8.html">sysbench压测mysql</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j3z3o8.html">【javascript】函数中的this详解 &mdash; 大家准备好瓜子，我要讲故事啦~~</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk41wd8.html">Linux常见命令（系统命令）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2droj9.html">python爬虫之线程池和进程池</a>
		</li>
						<li><a href="https://www.batexi.com/a/q252wk3q.html">Android XML shape 标签使用详解（apk瘦身，减少内存好帮手）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rdoe58.html">python第七十六天--堡垒机完成</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o17331q.html">HDU 5663 Hillan and the girl &lpar;莫比乌斯反演 &plus; 分块&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvex4xy9.html">在 Linux 系统下使用 PhotoRec 工具来恢复已删除或丢失的文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/96362439.html">configChanges</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jejm5e8.html">sqlserver2008自动备份，自动删除较早的别分文件</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qy14m5mq.html">基于Ceph快照的异地灾备设计</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zl6kg9.html">ajax问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mel33oq.html">Sublime Text3常用插件以及安装方法&lpar;实用&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljny369.html">JAVA内存关注总结&comma;作为个程序员需要对自己系统的每块内存做到了如指掌</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdk1nz9.html">Android SQLite总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojvxw1q.html">制作 OpenStack Linux 镜像 - 每天5分钟玩转 OpenStack（151）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojvxmlq.html">beautifulsoup 获取a&lpar;tag&rpar;的属性href</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jznyww8.html">asp&period;net core mvc剖析：处理管道构建</a>
			</li>
						<li><a href="https://www.batexi.com/a/90me7d38.html">11 Python&plus;selenium对下拉框（select）进行处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zn7vk9.html">第十八篇  js高级知识---作用域链</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
